/***************************************************************************
                               cmappluginbase.cpp
                             -------------------
    begin                : Mon Aug 6 2001
    copyright            : (C) 2001 by Kmud Developer Team
    email                : kmud-devel@kmud.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cmappluginbase.h"

#include "cmappropertiespanebase.h"
#include "cmaptoolbase.h"
#include "cmapviewmanagerbase.h"
#include "cmapmanager.h"

#include <kmudsetuppane.h>

CMapPluginBase::CMapPluginBase(CMapManager *manager,QObject *parent, const char *name ) : KParts::Plugin(parent,name)
{
	mapManager = manager;

	toolList.setAutoDelete(false);
	viewList.setAutoDelete(false);
	paneList.setAutoDelete(false);
}

CMapPluginBase::~CMapPluginBase()
{
}

/** Used to get a list of the view managers */
QList<CMapViewManagerBase> CMapPluginBase::getViewList(void)
{
	return viewList;
}

/** Used to get a list of the tools */
QList<CMapToolBase> CMapPluginBase::getToolList(void)
{
	return toolList;
}

/** Used to get a list of the property pages for a map element */
QList<CMapPropertiesPaneBase> CMapPluginBase::getPropertyPanes(elementTyp ,CMapElement *,QWidget *)
{
	QList<CMapPropertiesPaneBase> list;

	return list;
}

/** Used to tell the tool were to find the map manager */
void CMapPluginBase::setManager(CMapManager *manager)
{
	mapManager = manager;
}

/** Used to get the map manager */
CMapManager *CMapPluginBase::getManager(void)
{
	return mapManager;
}

/** This is called before a element menu is openend */
void CMapPluginBase::beforeOpenElementMenu(CMapElement *)
{
}

/** This is called before a element is deleted */
void CMapPluginBase::beforeElementDeleted(CMapElement *)
{
}

/** This is called when a element is changed */
void CMapPluginBase::elementChanged(CMapElement *)
{
}

void CMapPluginBase::saveConfigOptions(void)
{
}

void CMapPluginBase::loadConfigOptions(void)
{
}

void CMapPluginBase::mapErased(void)
{
}

/** This method is used to get a list of global config panes. It should return a empty list
  * If none are provided by this part */
QList<KmudSetupPane> CMapPluginBase::createGlobalConfigPanes(QWidget *)
{
	QList<KmudSetupPane> panels;

	panels.clear();

	return panels;
}

/** This method is used to get a list of profile config panes. It should return a empty list
  * If none are provided by this part */
QList<KmudSetupPane> CMapPluginBase::createProfileConfigPanes(QWidget *)
{
	QList<KmudSetupPane> panels;

	panels.clear();

	return panels;
}
